import type { PropDefinitions, RemoteEvent, RemoteElement } from '../types';
import type { default as Handle } from './handle';
import type { ComponentChild } from './component-extras';
interface Component<P = {}, S = {}, SS = {}> {
    _fritzId: number;
    _fritzHandles: Map<number, Handle>;
    _fritzPort: MessagePort;
    _dirty: boolean | undefined;
    localName: string;
    shouldComponentUpdate(props: P): boolean;
    componentDidMount(): void;
    getSnapshotBeforeUpdate(prevProps: P, prevState: S): SS | null;
    componentDidUpdate(prevProps: P, prevState: S, snapshot: SS | null): void;
}
declare abstract class Component<P, S extends {}, SS> {
    state: S;
    props: P;
    constructor();
    dispatch(ev: RemoteEvent): void;
    setState<K extends keyof S>(state: Record<K, S[K]> | ((state: S, props: P) => S)): void;
    componentWillUnmount(): void;
    abstract render(props: P, state: S): ComponentChild;
}
export interface ComponentConstructor<P = {}, S extends {} = {}, SS = {}> {
    props?: PropDefinitions;
    events?: Array<string>;
    styles?: string | Array<RemoteElement | string>;
    new (...params: any[]): Component<P, S, SS>;
}
export default Component;
